#!/bin/sh

export STT_REFPATH=../../estutter/lib
ESTT=../../util/estt-static
test_data='no
yes
2
'
outfilter='
s/<[0-9A-Fa-fx]*>/<ptr>/g;
s/[[]code=[0-9A-Fa-fx]*/code=ptr/g;
'

err=0
for n in *.stt
do
	echo "$test_data" | $ESTT $n | sed "$outfilter" > $n.out
	diff -u ref/$n.ref $n.out && rm $n.out
	if test "$?" -ne 0
	then
		err=1
	fi
done

if test $err -eq 0
then
	echo "all okay - QC PASS."
	true
else
	false
fi
