static STT_BUILTIN(sb_make_dictionary)
{
	return stt_create_dict(ctx->stt);
}

static STT_BUILTIN(sb_dictionary_keys)
{
	stt_obj_t *dict, *list;
	unsigned long i;
	STT_ARG_DICT(ctx->stt, dict);

	list = stt_create_nil(ctx->stt);
	for(i=0; i<dict->d.dict.size; i++) {
		if(dict->d.dict.data[i].name && (stt_intptr_t)dict->d.dict.data[i].name != 1)
			list = stt_create_cons(ctx->stt, dict->d.dict.data[i].name, list);
	}

	return list;
}

static STT_BUILTIN(sb_dref)
{
	stt_obj_t *value, *dict, *key;
	STT_ARG_DICT(ctx->stt, dict);
	STT_ARG_OBJ(ctx->stt, key);

	value = stt_dictget(dict, key);
	return value ? value : stt_create_nil(ctx->stt);
}

static STT_BUILTIN(sb_ddel)
{
	stt_obj_t *dict, *key;
	STT_ARG_DICT(ctx->stt, dict);
	STT_ARG_OBJ(ctx->stt, key);

	return stt_dictdel(dict, key) ? stt_create_t(ctx->stt) : stt_create_nil(ctx->stt);
}

static STT_BUILTIN(sb_dput)
{
	stt_obj_t *dict, *key, *value;

	STT_ARG_DICT(ctx->stt, dict);
	STT_ARG_OBJ(ctx->stt, key);
	STT_ARG_OBJ(ctx->stt, value);

	stt_dictput(ctx->stt, dict, stt_hashfunc(key), key, value);
	return stt_create_t(ctx->stt);
}
