#ifndef STT_COMPAT_H
#define STT_COMPAT_H

#include <stdarg.h>

/* Not part of c89 */
char *stt_strdup(const char *src);

/* safe function pointer <-> data pointer casts */
typedef double (*stt_fptr)();
void *stt_F2V(stt_fptr func);
stt_fptr stt_V2F(void *v);

/* strcasecmp is a 4.4BSD invention - most systemshave it, but feature
   macros and includes may differ. Safer to reimplement. */
int stt_strcasecmp(const char *str1, const char *str2);

char *stt_asvprintf(char *small, size_t small_len, int *need2free, size_t *rlen, const char *fmt, va_list ap_orig);

#endif
