#ifndef _STT_READ_H
#define _STT_READ_H

#include <estutter/types.h>

enum {
	STT_RS_NORM,
	STT_RS_COMMENT,
	STT_RS_COMMENT_BODY,
	STT_RS_COMMENT_1,
	STT_RS_COMMENT_FILE,
	STT_RS_STRING,
	STT_RS_STRING_ESCAPE,
	STT_RS_INTEGER,
	STT_RS_NUM,
	STT_RS_MINUS,
	STT_RS_SYMBOL,
	STT_RS_DOT,
	STT_RS_COLON,
	STT_RS_COMMA,
	STT_RS_STRING_ESCAPE_HEX,
	STT_RS_STRING_ESCAPE_HEX_2,
	STT_RS_HASH,
	STT_RS_CHAR_CONST,
	STT_RS_RAW_QUOT,
	STT_RS_RAW_DBL,
	STT_RS_RAW_QUOT_ESC,
	STT_RS_RAW_DBL_ESC,
	STT_RS_HASH_INT
};

/* parser state */
typedef struct {
	stt_ctx_t *stt;

	int state;
	size_t line, col;
	stt_obj_t *out;
	stt_obj_t *stack;
	stt_obj_t *act;

	char *token;
	size_t buflen, strlen;
	int ahead; /* boolean */

	char ch;

	stt_obj_t *label; /* assoclist of #1# labels */
	int stacklabel;
} stt_read_state_t;

/* create stt_read_state_t */
stt_read_state_t *stt_create_read_state(stt_ctx_t *stt);

/* destroy stt_read_state_t */
void stt_free_read_state(stt_read_state_t *s);

/* reset parser */
void stt_read_reset(stt_read_state_t *s);

/* read a character */
stt_obj_t *stt_read_ch(stt_read_state_t *s, int ch);

/* read an object from a stream */
stt_obj_t *stt_readstream(stt_varctx_t *ctx, stt_obj_t *str);

#endif
